<?php 
	function xl_init_admin_menus(){	
		global $xl_dir, $xl_base, $text_domain,$xl_path;

		add_menu_page(__("XtremeLocator", $text_domain), __("XtremeLocator", $text_domain), "manage_options","xtreme-locator", "control_panel",$xl_base.'/icons/icon-16-xtremelocator.png');
		add_submenu_page("xtreme-locator", __("Settings", $text_domain), __("Settings", $text_domain), "manage_options","xtreme-locator-settings","xl_settings");		
		add_submenu_page('xtreme-locator', __("CSS styles", $text_domain), __("Css styles", $text_domain), "manage_options","xtreme-locator-css",'xl_css_styles');
		add_submenu_page('xtreme-locator', __("Standard search", $text_domain), __("Standard search", $text_domain), "manage_options","xtreme-locator-standard-search",'xl_standard_search');
		add_submenu_page('xtreme-locator',__("Advanced search", $text_domain), __("Advanced search", $text_domain), "manage_options","xtreme-locator-advanced-search", 'xl_advanced_search');
		add_submenu_page('xtreme-locator',__("Custom search", $text_domain), __("Custom search", $text_domain), "manage_options","xtreme-locator-custom-search", 'xl_custom_search');
		add_submenu_page('xtreme-locator', __("All Locations Map", $text_domain), __("All location map", $text_domain), "manage_options","xtreme-locator-all-locations", 'xl_all_location');
		add_submenu_page('xtreme-locator', __("Location listing", $text_domain), __("Location listing", $text_domain), "manage_options","xtreme-locator-listing", 'xl_location_listing');
		add_submenu_page('xtreme-locator', __("Location admin login", $text_domain), __("Location admin login", $text_domain), "manage_options","xtreme-locator-admin", 'xl_location_admin');
		
	}
	function xl_uninstall(){
		global $wpdb;
		$fields=$wpdb->get_results("DROP TABLE `".$wpdb->prefix."xtremelocator_config`, `".$wpdb->prefix."xtremelocator_css`, `".$wpdb->prefix."xtremelocator_fields`, `".$wpdb->prefix."xtremelocator_layouts`");  		
	}
	function xl_add_admin_stylesheet() {
	  global $xl_base;
	  print "<link rel='stylesheet' type='text/css' href='".$xl_base."/admin.css'>\n";
	}
	function xl_add_public_stylesheet() {
	  global $xl_base;
	  print "<link rel='stylesheet' type='text/css' href='".$xl_base."/xtremelocator_pub.css'>\n";	  
	}
	function control_panel(){
		global $xl_dir, $xl_base, $text_domain,$xl_path;	
		include_once($xl_path."/views/control_panel.php");
	}
	function getConfig($cid){
		global $wpdb;
		$config=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_config` WHERE type=".$cid);
		return $config[0];
	}
	function getAllFields(){
        global $wpdb;
		$fields=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_fields`");  
        return $fields;
    }
	function getfieldlayout($fid,$type){ 
		global $wpdb;		
        if(!isset($_GET['sort_by'])||$_GET['sort_by']=="field_name"){
            $sort_by='fl.field_name';
        }else{
            $sort_by="layouts.".$_GET['sort_by'];
        }
        $rows=$wpdb->get_results("SELECT * FROM ".$wpdb->prefix."xtremelocator_fields AS fl LEFT JOIN ".$wpdb->prefix."xtremelocator_layouts AS layouts ON fl.id=layouts.field_id WHERE layouts.layout_id='".$fid."' AND layouts.type=".$type." AND fl.enabled=1 ORDER BY fl.enabled DESC, ".$sort_by." ASC " );        
        $a=array();
        foreach ($rows as $row){
            $a[$row->id]=$row;
        }        
        $rows=$wpdb->get_results("SELECT * FROM ".$wpdb->prefix."xtremelocator_fields AS fl WHERE fl.id NOT IN (SELECT field_id from ".$wpdb->prefix."xtremelocator_layouts AS layouts WHERE layouts.layout_id='".$fid."' AND layouts.type=".$type.") AND fl.enabled=1");               
        foreach ($rows as $row){
            $row->layout_id=$fid;
            $row->type=$type;
            $row->visible=0;
            $row->show_title=0;
            $row->order=0;
            $row->lincable=0;            
            $a[$row->id]=$row;
        }  
       
        return $a;
    }
	function saveConfigData($results,$cid){
		global $wpdb;
		$fields="";
		foreach($results as $name=>$value){
			if(count($value)==1&&$name!='lincable'&&$name!='field list'&&$name!='title'&&$name!='URLcode'){
				$fields.=" ".$name.'="'.$value.'",';
			};
		}		
		$update_result= $wpdb->get_results(" UPDATE `".$wpdb->prefix."xtremelocator_config` SET ".substr($fields,0,-1)." WHERE type =".$cid);			
	}
	function saveLayoutData($results,$lid){
			global $wpdb;			
            $visible=$results['visible'];
            $show_title=$results['title'];
            $order=$results['order'];
            unset($results['visible']);
            unset($results['title']);
            unset($results['order']);           
            $r=$wpdb->get_results("DELETE  FROM ".$wpdb->prefix."xtremelocator_layouts WHERE layout_id=".$lid);
          
            $fields=getAllFields();
            foreach($fields as $field){
                $r=$wpdb->get_results("INSERT INTO `".$wpdb->prefix."xtremelocator_layouts` ( `field_id` , `layout_id` , `type` ,  `visible` , `show_title` , `order` , `lincable` ) VALUES ( '".$field->id."', '".$lid."', '1', '".(isset($visible['1_'.$lid.'_'.$field->id])?1:0)."', '".(isset($show_title['1_'.$lid.'_'.$field->id])?1:0)."', '".($order['1_'.$lid.'_'.$field->id]>0?$order['1_'.$lid.'_'.$field->id]:$field->id)."', '".($results['lincable']==$field->id?1:0)."' )"); 
                
                
                $r=$wpdb->get_results("INSERT INTO `".$wpdb->prefix."xtremelocator_layouts` ( `field_id` , `layout_id` , `type` ,  `visible` , `show_title` , `order` , `lincable` ) VALUES ( '".$field->id."', '".$lid."', '2', '".(isset($visible['2_'.$lid.'_'.$field->id])?1:0)."', '".(isset($show_title['2_'.$lid.'_'.$field->id])?1:0)."', '".($order['2_'.$lid.'_'.$field->id]>0?$order['2_'.$lid.'_'.$field->id]:$field->id)."', '".($results['lincable']==$field->id?1:0)."' )"); 
                
            }            
            unset($results['lincable']);         
        return $results;
    }
	function xl_settings(){
		global $xl_dir, $xl_base, $text_domain,$xl_path,$wpdb;		
		
		if(isset($_POST['field_action'])){
				if($_POST['field_action']=="save"){
					if(isset($_POST['xl']['id'])){
						$update_result= $wpdb->get_results("UPDATE `".$wpdb->prefix."xtremelocator_fields` SET `field_id2` = '".$_POST['xl']['field_id2']."', field_name='".$_POST['xl']['field_name']."' , display_name='".$_POST['xl']['display_name']."' WHERE `".$wpdb->prefix."xtremelocator_fields`.`id` =".$_POST['xl']['id'].";");
					}else{
						$update_result= $wpdb->get_results("INSERT INTO`".$wpdb->prefix."xtremelocator_fields` (id,field_id2,field_name,enabled,display_name) VALUES (NULL,'".$_POST['xl']['field_id2']."', '".$_POST['xl']['field_name']."',1,'".$_POST['xl']['display_name']."');");
					}
				}
		}
		
		if((isset($_GET['id'])||(isset($_POST['action'])&&$_POST['action']=="add_field"))&&!isset($_POST['field_action'])){
			if(isset($_GET['id'])){
					$field=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_fields` WHERE id=".$_GET['id']);
					
			}
			include_once($xl_path."/views/add_field.php");
			
		}else{
			if(count($_POST)>0&&isset($_POST['action'])){
				if($_POST['action']=="update"){
					$update_result= $wpdb->get_results("UPDATE `".$wpdb->prefix."xtremelocator_config` SET `site_id` = '".$_POST['xl']['site_id']."', domain='".$_POST['xl']['domain']."', not_found='".$_POST['xl']['not_found']."' WHERE `".$wpdb->prefix."xtremelocator_config`.`id` =1;");
									
				}elseif($_POST['action']=="remove_field"){
					if(count($_POST['remove']>0)){
						$ids=implode(',',array_keys($_POST['remove']));
						$update_result= $wpdb->get_results("DELETE FROM ".$wpdb->prefix."xtremelocator_fields WHERE id in (".$ids.")"  );					
				   }
				}elseif($_POST['action']=="update_states"){
					if(count($_POST['enabled'])>0){
						$keys=array_keys($_POST['enabled']);
					}else{
						$keys=array(0);
					}
					   
					$update_result= $wpdb->get_results(" UPDATE `".$wpdb->prefix."xtremelocator_fields` SET enabled=0 WHERE id NOT IN (".implode(',', $keys).")");				   
					$update_result= $wpdb->get_results(" UPDATE `".$wpdb->prefix."xtremelocator_fields` SET enabled=1 WHERE id IN (".implode(',', $keys).")");
					
				}
			}
			$config=getConfig(1);
			$fields= getAllFields();
			include_once($xl_path."/views/settings.php");
		}
	}
	function xl_get_css(){	
		global $wpdb;
		$css=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_css`");  
        return $css;
	}
	function xl_get_css_array(){
       global $wpdb;
	   $css=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_css`");  
       $ff=array();  
       foreach ($css as $field){
            $ff[$field->name]['name']=$field->name;
            $ff[$field->name]['class']=$field->class;
       }
     
       return $ff;
    }
	function xl_css_styles(){
		global $xl_dir, $xl_base, $text_domain,$xl_path,$wpdb;	
		//chmod($xl_path."/xtremelocator_pub.css", 0777);
	    if(count($_POST)>0){
			foreach ($_POST['xl'] as $nm=>$css){        
				$result=$wpdb->get_results("UPDATE ".$wpdb->prefix."xtremelocator_css SET `class` = '".$css."' WHERE `id` =".$nm);				      
			} 
			$cssFile = $xl_path."/xtremelocator_pub.css";   			
			$fh = fopen($cssFile, 'w') or die("can't open file");
			$stringData = $_POST["css_source"];
			fwrite($fh, $stringData);   
			fclose($fh);
		}
		$css=xl_get_css();		
		include_once($xl_path."/views/css_styles.php");
	}
	
	function xl_standard_search(){
		global $xl_dir, $xl_base, $text_domain,$xl_path,$wpdb;	
		if(count($_POST)>0){			
			$post=saveLayoutData($_POST,2);
			saveConfigData($_POST,2);
		}	
		$config=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_config` WHERE type=1 OR type=2" );
		$row=$config[1];
		$fields=getfieldLayout(2,1);
		$fields2=getfieldLayout(2,2);
		$afields=getAllFields();		
		include_once($xl_path."/views/standard_search.php");	
	}
	
	function xl_advanced_search(){
		global $xl_dir, $xl_base, $text_domain,$xl_path,$wpdb;	
		
		if(count($_POST)>0){			
			$post=saveLayoutData($_POST,3);
			saveConfigData($_POST,3);
		}	
		$config=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_config` WHERE type=1 OR type=3" );
		$row=$config[1];
		$fields=getfieldLayout(3,1);
		$fields2=getfieldLayout(3,2);
		$afields=getAllFields();		
		include_once($xl_path."/views/advanced_search.php");	
	}
	
	function xl_custom_search(){
		global $xl_dir, $xl_base, $text_domain,$xl_path,$wpdb;	
		
		if(count($_POST)>0){			
			$post=saveLayoutData($_POST,6);
			saveConfigData($_POST,6);
		}	
		$config=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_config` WHERE type=1 OR type=6" );
		$row=$config[1];
		$fields=getfieldLayout(6,1);
		$fields2=getfieldLayout(6,2);
		$afields=getAllFields();		
		include_once($xl_path."/views/custom_search.php");	
	}
	
	function xl_all_location(){
		global $xl_dir, $xl_base, $text_domain,$xl_path,$wpdb;		
		if(count($_POST)>0){			
			saveConfigData($_POST,5);
		}	
		$config=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_config` WHERE type=1 OR type=5" );
		$row=$config[1];
		$gobal_config=$config[0];
		include_once($xl_path."/views/all_location.php");
	}
	
	function xl_location_listing(){
		global $xl_dir, $xl_base, $text_domain,$xl_path,$wpdb;	
		if(count($_POST)>0){			
			$post=saveLayoutData($_POST,4);
			saveConfigData($_POST,4);
		}	
		$config=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_config` WHERE type=1 OR type=4" );
		$row=$config[1];
		$fields=getfieldLayout(4,1);
		$fields2=getfieldLayout(4,2);
		$afields=getAllFields();		
		include_once($xl_path."/views/location_listing.php");	
	}
	
	function xl_location_admin(){
		global $xl_dir, $xl_base, $text_domain,$xl_path,$wpdb;	
		$config=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_config` WHERE type=1" );
		
		include_once($xl_path."/views/location_admin.php");
	}
	 function makeList($name,$elements,$active,$id="",$extra=""){
        $res='<select name="'.$name.'" id="'.$id.'">';
        foreach($elements as $element=>$value){
            $res.='<option value="'.$value.'" '.($value==$active?'selected="selected"':'').' '.$extra.'>'.$element.'</option>';
        }
        $res.='</select>';
        return $res;
    }
	
	 function getFields(){
       global $wpdb;	
       $fields=$wpdb->get_results("SELECT * FROM ".$wpdb->prefix."xtremelocator_fields WHERE enabled=1" );	
       $ff=array();  
       foreach ($fields as $field){
            $ff[]=$field->field_name;
       }        
       $ff[]='_id';
      
       return $ff;
    }
    function getLayout($fid,$type){        
		global $wpdb;	
		$rows=$wpdb->get_results("SELECT * FROM ".$wpdb->prefix."xtremelocator_layouts AS layouts LEFT JOIN ".$wpdb->prefix."xtremelocator_fields AS fl  ON fl.id=layouts.field_id WHERE layouts.layout_id='".$fid."' AND layouts.type=".$type." AND fl.enabled=1 AND layouts.visible=1 ORDER BY `layouts`.`order` ASC "  );	
        $fields=array();
        foreach($rows as $row){
           $fields[$row->field_name]=array(); 
           $fields[$row->field_name]['field_name']=$row->field_name;
		   $fields[$row->field_name]['display_name']=$row->display_name;
           $fields[$row->field_name]['show_title']=$row->show_title;
           $fields[$row->field_name]['lincable']=$row->lincable;
        }
        
        return $fields;
    }
    
    function getCountries(){
        return array(" "=>0,"USA"=>1,"Canada"=>2);
    }
    function getLocations($fields,$type){
		global $xl_dir, $xl_base, $text_domain,$xl_path,$wpdb;	
        $config=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_config` WHERE type=1 OR type=".$type );		
		$searchC=$config[1];
        $sysFields=array('option','view','jfcookie','Itemid','format');
        $globalC=$config[0];        
        $allColumns = implode(",", getFields());
        
        $searchOptions=array(
            "sid" => $globalC->site_id,
            "type" => "advanced",
            "format" => "CSV",
            "csv_columns" => $allColumns                        
        );
        $c = curl_init($globalC->domain."/visitor/findLocations.php");
        foreach ($_REQUEST as $k => $v)
        {                
                    if(!in_array($k,$sysFields)){
                        $searchOptions[$k] = $v;
                    }
               
        }       
        $fields = "";
        foreach ($searchOptions as $name => $val)
        {
            if (strlen($fields) > 0)
            {
                $fields .= "&";
            }
            $fields .= $name."=".urlencode($val);
        }   
        //print_r($searchOptions);    
        curl_setopt($c, CURLOPT_POST, 1);
        curl_setopt($c, CURLOPT_POSTFIELDS, $fields);
        ob_start();
        curl_exec($c);
        $response = ob_get_contents();  
        ob_end_clean();         
        //print_r($response); 
        
        $rows = explode("\n", trim($response));
        $r = array();
        $ca = explode(",", $allColumns);
        foreach ($rows as $row)
        {
            if (strstr($row, '"'))
            {
                $ce = explode(",", $row);
                $f = array();
                $z = array();
                $field = "";
                foreach ($ce as $v)
                {
                    $field .= $v;
                    if ($field[0] == '"' && (substr($field, strlen($field)-1, 1) != '"' || strlen($field) == 1))
                    {
                        $field .= ",";
                    }
                    else
                    {
                        $field = str_replace("\"\"", "\"", $field);
                        if ($field[0] == '"')
                        {
                            $field = substr($field, 1, strlen($field) - 2);
                        }
                        $f[] = $field;
                        $field = "";
                    }
                }
                foreach ($f as $k => $v)
                {
                    $z[ucwords($ca[$k])] = $f[$k];
                }
                $r[] = $z;
            }
        }      
        $_SESSION["xl_results"] = $r;
        $_SESSION["pos"] = 0;
        //print_r($_SESSION["xl_results"]);
    }	
	function includeLocator($content){
		global $xl_dir, $xl_base, $text_domain,$xl_path,$wpdb,$hide_widget; 
		require_once($xl_path."/pub/js.php");			
		if(preg_match('|\[Xtreme-locator-standard|', $content)) {
			if(isset($_GET['search_type'])&&$_GET['search_type']=='advanced'){
				$out1=includeAdvancedSearch();
			}elseif(isset($_GET['search_type'])&&$_GET['search_type']=='listing'){
				$out1=includeLocationListing();
			}else{
				$out1=includeStandardSearch();
			}			
			return eregi_replace("\[Xtreme-locator-standard(.*)?\]", $out1, $content);			
		}elseif(preg_match('|\[Xtreme-locator-advanced|', $content)){
			if(isset($_GET['search_type'])&&$_GET['search_type']=='listing'){
				$out1=includeLocationListing();
			}else{
				$out1=includeAdvancedSearch();
			}return eregi_replace("\[Xtreme-locator-advanced(.*)?\]", $out1, $content);
		}elseif(preg_match('|\[Xtreme-locator-custom|', $content)){
			if(isset($_GET['search_type'])&&$_GET['search_type']=='listing'){
				$out1=includeLocationListing();
			}else{
				$out1=includeCustomSearch();
			}		
			return eregi_replace("\[Xtreme-locator-custom(.*)?\]", $out1, $content);
		}
		elseif(preg_match('|\[Xtreme-locator-listing|', $content)){
			if(isset($_GET['search_type'])&&$_GET['search_type']=='advanced'){
				$out1=includeAdvancedSearch();
			}else{
				$out1=includeLocationListing();
			}
			return eregi_replace("\[Xtreme-locator-listing(.*)?\]", $out1, $content);
		}elseif(preg_match('|\[Xtreme-locator-all|', $content)){
			if(isset($_GET['search_type'])&&$_GET['search_type']=='advanced'){
				$out1=includeAdvancedSearch();
			}elseif(isset($_GET['search_type'])&&$_GET['search_type']=='listing'){
				$out1=includeLocationListing();
			}else{
				$out1=includeAllMap();
			}				
			return eregi_replace("\[Xtreme-locator-all(.*)?\]", $out1, $content);
		}else{
			
			return $content;			
		}
	}
	function includeStandardSearch(){
		global $xl_dir, $xl_base, $text_domain,$xl_path,$wpdb;	
			$config=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_config` WHERE type=1 OR type=2" );
			$conf=$config[1];
			$gconf=$config[0];
			$list_fields=getLayout(2,1);
			$detailed_fields=getLayout(2,2);
			$css=xl_get_css_array();		
			
			if(count($_POST)>0){
				getLocations($_REQUEST,2);
				$_SESSION["xl_search"] = $_POST;
			}else{
				if(!isset($_GET['lid'])&&!isset($_GET['pos'])){			
				if(isset($_SESSION["xl_search"])) unset($_SESSION["xl_search"]);
				if(isset($_SESSION["xl_results"])) unset($_SESSION["xl_results"]);
				}
			}
			
			if(!isset($_SESSION["xl_search"]['zip'])||$_SESSION["xl_search"]['zip']==""){
				if(isset($_SESSION["xl_search"])) unset($_SESSION["xl_search"]);
			}
		
			ob_start();				
				if(isset($_SESSION["xl_results"])){ 
					if((isset($_GET['lid'])&&$conf->show_form_details==1)||(!isset($_GET['lid'])&&$conf->show_form_list==1)){
						require($xl_path."/pub/standard_search_form.php");
					}else{
						require($xl_path."/pub/search_again.php");
					}
					require($xl_path."/pub/standard_search_results.php");
				}else{
					require($xl_path."/pub/standard_search_form.php");
				}
				$out1 = ob_get_contents();

			ob_end_clean();							
			return $out1;
	}
	function includeAdvancedSearch(){
			global $xl_dir, $xl_base, $text_domain,$xl_path,$wpdb;	
			$config=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_config` WHERE type=1 OR type=3" );
			$conf=$config[1];
			$gconf=$config[0];
			$list_fields=getLayout(3,1);
			$detailed_fields=getLayout(3,2);
			$css=xl_get_css_array();		
			
			if(count($_POST)>0){
				getLocations($_REQUEST,3);				
			}else{
				if(!isset($_GET['lid'])&&!isset($_GET['pos'])){			
				if(isset($_SESSION["xl_search"])) unset($_SESSION["xl_search"]);
				if(isset($_SESSION["xl_results"])) unset($_SESSION["xl_results"]);
				}
			}
			ob_start();
				
				if(isset($_SESSION["xl_results"])){ 
					if((isset($_GET['lid'])&&$conf->show_form_details==1)||(!isset($_GET['lid'])&&$conf->show_form_list==1)){
						require($xl_path."/pub/advanced_search_form.php");
					}else{
						require($xl_path."/pub/search_again.php");
					}
					require($xl_path."/pub/advanced_search_results.php");
				}else{
					require($xl_path."/pub/advanced_search_form.php");
				}
				$out1 = ob_get_contents();
			ob_end_clean();							
			return $out1;
	}
	function includeCustomSearch(){
			global $xl_dir, $xl_base, $text_domain,$xl_path,$wpdb;	
			$config=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_config` WHERE type=1 OR type=6" );
			$conf=$config[1];
			$gconf=$config[0];
			$list_fields=getLayout(6,1);
			$detailed_fields=getLayout(6,2);
			$css=xl_get_css_array();		
			
			if(count($_POST)>0){
				getLocations($_REQUEST,6);				
			}else{
				if(!isset($_GET['lid'])&&!isset($_GET['pos'])){			
				if(isset($_SESSION["xl_search"])) unset($_SESSION["xl_search"]);
				if(isset($_SESSION["xl_results"])) unset($_SESSION["xl_results"]);
				}
			}
			ob_start();
				
				if(isset($_SESSION["xl_results"])){ 
					if((isset($_GET['lid'])&&$conf->show_form_details==1)||(!isset($_GET['lid'])&&$conf->show_form_list==1)){
						require($xl_path."/pub/custom_search_form.php");
					}else{
						require($xl_path."/pub/search_again.php");
					}
					require($xl_path."/pub/custom_search_results.php");
				}else{
					require($xl_path."/pub/custom_search_form.php");
				}
				$out1 = ob_get_contents();
			ob_end_clean();							
			return $out1;
	}
	function includeLocationListing(){
			global $xl_dir, $xl_base, $text_domain,$xl_path,$wpdb;	
			$config=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_config` WHERE type=1 OR type=4" );
			$conf=$config[1];
			$gconf=$config[0];
			$list_fields=getLayout(4,1);
			$detailed_fields=getLayout(4,2);
			$css=xl_get_css_array();			
			getLocations($_REQUEST,3);
			ob_start();
				require($xl_path."/pub/location_listing.php");				
				$out1 = ob_get_contents();
			ob_end_clean();							
			return $out1;
	}
	function includeAllMap(){
			global $xl_dir, $xl_base, $text_domain,$xl_path,$wpdb;	
			$config=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_config` WHERE type=1 OR type=5" );
			$conf=$config[1];
			$gconf=$config[0];			
			$css=xl_get_css_array();			
			getLocations($_REQUEST,5);
			ob_start();
				require($xl_path."/pub/all_map.php");				
				$out1 = ob_get_contents();
			ob_end_clean();							
			return $out1;
	}
	function xl_register_widgets(){
		 global $xl_dir, $xl_base, $text_domain,$xl_path,$wpdb;
		 wp_register_sidebar_widget("10",__("XtremeLocator search box", $text_domain), 'xl_search_widget',array("classname"));
		 wp_register_widget_control("10",__("XtremeLocator search box", $text_domain),"xl_standard_search_widget_init",300,300);
		 	
	}
	function xl_search_widget(){
		global $xl_dir, $xl_base, $text_domain,$xl_path,$wpdb;	
		$url=get_option('xl_widget_url');
		$type=get_option('xl_search_type');
		$title=get_option('xl_widget_title');
		$description=get_option('xl_widget_desc');
		$zip=get_option('xl_widget_zip');
		echo '<aside id="xl_pub_widget" class="widget  widget-container widget_xl"><h2 class="widget-title">'.$title.'</h2>';
		echo '<p id="xl_pub_widget_description">'.$description.'</p>';
		$config=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_config` WHERE type=2" );
		$conf=$config[0];
		$gconfig=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_config` WHERE type=1" );
		$gconf=$gconfig[0];
		if($type==1){
						
			echo '<script type="text/javascript" > 
			function checkZipWidget(){									
					zip=document.getElementById("xl_pub_widget_zip");
					city=document.getElementById("xl_pub_widget_city");
					if(isNaN(zip.value)){
						city.value=zip.value;
						zip.value="";
					}						
			}</script>';
			echo '<form action="'.$url.'" method="post" id="xl_pub_widget_form" onSubmit="checkZipWidget()">';
			if($conf->search_type==0){
				echo ' <div><label for="xl_search_country" id="xl_search_country_label">'.__("Country", $text_domain).':</label><select id="XlocatorCountry" name="country" onChange="checkZip(this);">
          </select></div>';
			}
			echo '<div><label for="xl_pub_widget_zip" id="xl_pub_widget_zip_label">'.__($zip, $text_domain).':</label><input type="text" id="XlocatorZip" class="xl_pub_widget_zip" name="zip"> <input type="hidden" name="city" id="xl_pub_widget_city"  value=""></div>';
			if($conf->search_type==0){
				echo ' <script type="text/javascript" src="http://app.xtremelocator.com/visitor/searchByCountryJS.php?siteId='.$gconf->site_id.'"></script>';
			}
			if($conf->search_type==2){
				echo '<div><label for="xl_pub_search_distance" id="xl_pub_search_distance_label" >'.__("Distance", $text_domain).':</label><input type="text" name="distance" id="xl_search_distance" value="'.isset($_SESSION["xl_search"]['distance'])?$_SESSION["xl_search"]['distance']:"".'" name="distance"/></div>';
			}
			echo '<input type="submit" value="'.__("Search", $text_domain).'" id="xl_pub_search_submit"></form>';
		}else{
			$config=$wpdb->get_results("SELECT * FROM `".$wpdb->prefix."xtremelocator_config` WHERE type=3" );
			$conf=$config[0];
			echo '<div id="xl_pub_advanced_form_code">'.$conf->form_code.'</div>';
		}
		echo '</aside>';
	}
	function xl_standard_search_widget_init(){
		global $xl_dir, $xl_base, $text_domain,$xl_path,$wpdb;		
		$url=get_option('xl_widget_url');
		$type=get_option('xl_search_type');
		$title=get_option('xl_widget_title');
		$description=get_option('xl_widget_desc');
		$zip=get_option('xl_widget_zip');
		if(count($_POST)>0){
			if(isset($_POST['xl_widget_url'])){
				update_option('xl_widget_url',$_POST['xl_widget_url']);				
			}
			if(isset($_POST['xl_search_type'])){
				update_option('xl_search_type',$_POST['xl_search_type']);				
			}
			if(isset($_POST['xl_widget_title'])){
				update_option('xl_widget_title',$_POST['xl_widget_title']);				
			}
			if(isset($_POST['xl_widget_desc'])){
				update_option('xl_widget_desc',$_POST['xl_widget_desc']);				
			}
			if(isset($_POST['xl_widget_zip'])){
				update_option('xl_widget_zip',$_POST['xl_widget_zip']);				
			}
		}
		echo __("Search type", $text_domain).' <select name="xl_search_type"><option value="1" '.($type==1?'selected="selected"':"").'>'.__("Standard search", $text_domain).'</option><option value="2" '.($type==2?'selected="selected"':"").'>'.__("Advanced search", $text_domain).'</option></select><br/>';	
		echo __("Full search URL", $text_domain).' <br/><input type="name" name="xl_widget_url" value="'.$url.'"/><br/>';	
		echo __("Box title", $text_domain).' <br/><input type="name" name="xl_widget_title" value="'.$title.'"/><br/>';
		echo __("Description", $text_domain).' <br/><textarea name="xl_widget_desc" cols="20" rows="5">'.$description.'</textarea><br/>';
		echo __("Zip title", $text_domain).' <br/><textarea name="xl_widget_zip" cols="20" rows="5">'.$zip.'</textarea>';
	}
	function checkLocatorTag($content){
		$url=get_option('xl_widget_url');
		//if($url==""){
			if(preg_match('|\[Xtreme-locator-standard|', $content)||preg_match('|\[Xtreme-locator-advanced|', $content)) {
				update_option('xl_widget_url',get_permalink( $_POST['post_ID']));
			}
		//}		
		return $content;		
	}
?>