<?php
/*
Plugin Name: Xtremelocator
Plugin URI: http://www.xtremelocator.com
Description: This plugin allows you to deploy the Xtreme Locator dealer locator  application on your Wordpress website.  Complete help files are available at the Xtreme Locator  website.
Version: 1.5
Author: Linas Adomavicius
Author URI: http://www.xtremelocator.com
License: GPL2
*/


/*Init variables*/
global $xl_dir, $xl_base, $xl_path,$hide_widget;
$text_domain="xl";
$xl_dir=dirname(plugin_basename(__FILE__)); 
$xl_base=get_option('siteurl')."/wp-content/plugins/".$xl_dir; 
$xl_path=ABSPATH."wp-content/plugins/".$xl_dir; 

if (session_id() == '') session_start();

/*Init variables end*/

add_action('admin_init', 'editor_admin_init');
add_action('admin_head', 'editor_admin_head');
 
function editor_admin_init() {
	wp_enqueue_script('word-count');
	wp_enqueue_script('post');
	wp_enqueue_script('editor');
	wp_enqueue_script('media-upload');
}
 
function editor_admin_head() {
	  wp_tiny_mce();
}

include_once("functions.xtremelocator.php");
include_once("install.xtremelocator.php");
//add_action('admin_print_scripts', 'xl_add_admin_javascript');
add_action('admin_print_styles','xl_add_admin_stylesheet');
add_action('wp_print_styles','xl_add_public_stylesheet');

register_activation_hook( __FILE__, 'xl_install');
register_uninstall_hook(__FILE__, 'xl_uninstall');

add_filter('the_content', 'includeLocator', 7);
add_filter('content_save_pre', 'checkLocatorTag', 7);

add_action('admin_menu', 'xl_init_admin_menus');

add_filter('option_update_plugins', 'xl_prevent_upgrade');
add_filter('transient_update_plugins', 'xl_prevent_upgrade');

load_plugin_textdomain('text_domain',false, "/wp-content/plugins/xtremelocator/languages/");

add_action("plugins_loaded", "xl_register_widgets");
	
?>
